#include "trempler_puzzle_entity"

void MapInit()
{
	/* Trempler */
	g_CustomEntityFuncs.RegisterCustomEntity( "trempler_puzzle_entity", "trempler_puzzle_entity" );
}


void MapActivate()
{
	/* Fix for telefragging in Andras' part by R.C. */
	CBaseEntity@ eTriggerScript = g_EntityFuncs.Create( "trigger_script", Vector(0,0,0), Vector(0,0,0), false, null );
	
	if( eTriggerScript !is null )
	{
		g_EntityFuncs.DispatchKeyValue( eTriggerScript.edict(), "targetname", "fix1_moveteleporter" );
		g_EntityFuncs.DispatchKeyValue( eTriggerScript.edict(), "m_iszScriptFunctionName", "AndrasMoveTeleport" );
		//g_Game.AlertMessage( at_console, "trigger_script set up! \n" );
	}
	
	CBaseEntity@ eMulti = g_EntityFuncs.FindEntityByTargetname(null, "rng_fake1");
	
	if( eMulti !is null )
	{
		CustomKeyvalues@ cks = eMulti.GetCustomKeyvalues();
		cks.SetKeyvalue( "fix1_moveteleporter", "0.7");
		
		g_EntityFuncs.DispatchKeyValue( eMulti.edict(), "fix1_moveteleporter", "0.7" );
		
		//g_Game.AlertMessage( at_console, "multi_manager hacked! \n" );
	}
	/* END: Fix for telefragging in Andras' part by R.C. */
	
	
	/* Fix for missing weapon strip in Zurd0's part by R.C. */
	CBaseEntity@ eBrushDonator = g_EntityFuncs.FindEntityByTargetname(null, "zurdo_teleport_3");
	
	if( eBrushDonator !is null )
	{
		//g_Game.AlertMessage( at_console, "brush donator found at: " + eBrushDonator.pev.origin.x + "," + eBrushDonator.pev.origin.y + "," + eBrushDonator.pev.origin.z + "! \n" );

		CBaseEntity@ eWeaponStrip = g_EntityFuncs.Create( "player_weaponstrip", eBrushDonator.pev.origin, eBrushDonator.pev.angles, false, null );	
		
		if( eWeaponStrip !is null )
		{
			//g_Game.AlertMessage( at_console, "weapon strip created! \n" );
			g_EntityFuncs.DispatchKeyValue( eWeaponStrip.edict(), "targetname", "fix2_strip" );
			
			CBaseEntity@ eTrigger = g_EntityFuncs.CreateEntity( "trigger_multiple", null, false );

			//g_Game.AlertMessage( at_console, "trigger_multiple created at: " + eTrigger.pev.origin.x + "," + eTrigger.pev.origin.y + "," + eTrigger.pev.origin.z + "! \n" );
			eTrigger.pev.model = "*430";
			g_EntityFuncs.DispatchKeyValue( eTrigger.edict(), "target", "fix2_strip" );
			g_EntityFuncs.DispatchSpawn( eTrigger.edict() );

		}
	}
	/* END: Fix for missing weapon strip in Zurd0's part by R.C. */
	
	
	/* Fix for crowbar missing custom respawn time in Walter's part by R.C. */
	
	CBaseEntity@ eCrowbar;
	@eCrowbar = g_EntityFuncs.Create( "weapon_crowbar", Vector(-7348.96, -3654.08, -270.61), Vector(0,330,0), false, null );
	g_EntityFuncs.DispatchKeyValue( eCrowbar.edict(), "m_flCustomRespawnTime", "0.1" );

	/* END: Fix for crowbar missing custom respawn time in Walter's part by R.C. */
}


void AndrasMoveTeleport( CBaseEntity@ pActivator, CBaseEntity@ pCaller, USE_TYPE useType, float flValue )
{
	CBaseEntity@ eDestination = g_EntityFuncs.FindEntityByTargetname(null, "rng_tele_a");
	
	if( eDestination !is null )
	{
		CBaseEntity@ eDestinationNew = g_EntityFuncs.Create( "info_target", eDestination.pev.origin + Vector(0,0,100), eDestination.pev.angles, false, null );
		
		if( eDestinationNew !is null )
		{
			g_EntityFuncs.DispatchKeyValue( eDestinationNew.edict(), "targetname", "fix1_newtarget" );
			
			CBaseEntity@ eTeleporter = g_EntityFuncs.FindEntityByTargetname(null, "rng_starttele");
			
			if( eTeleporter !is null )
			{
				g_EntityFuncs.DispatchKeyValue( eTeleporter.edict(), "target", "fix1_newtarget" );
			}
		}
	}
	
}













